More work on priviledge separation for host/authentication keyring.
[monkeysphere.git] / src / monkeysphere-server
index 65a7dda473177138176acd778c62d4ad59cb9360..1e05799a00ca9ef64cdabec33ce3a51cc3fa3cdc 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 
 # monkeysphere-server: MonkeySphere server admin tool
 #
 ########################################################################
 PGRM=$(basename $0)
 
-SHAREDIR=${SHAREDIR:-"/usr/share/monkeysphere"}
-export SHAREDIR
-. "${SHAREDIR}/common"
+SHARE=${SHARE:-"/usr/share/monkeysphere"}
+export SHARE
+. "${SHARE}/common" || exit 1
+
+VARLIB="/var/lib/monkeysphere"
+export VARLIB
 
 # date in UTF format if needed
 DATE=$(date -u '+%FT%T')
@@ -21,6 +24,9 @@ DATE=$(date -u '+%FT%T')
 # unset some environment variables that could screw things up
 GREP_OPTIONS=
 
+# default return code
+ERR=0
+
 ########################################################################
 # FUNCTIONS
 ########################################################################
@@ -28,40 +34,208 @@ GREP_OPTIONS=
 usage() {
 cat <<EOF
 usage: $PGRM <subcommand> [args]
-Monkeysphere server admin tool.
+MonkeySphere server admin tool.
 
 subcommands:
-  update-users (s) [USER]...            update users authorized_keys files
-  gen-key (g)                           generate gpg key for the server
-  publish-key (p)                       publish server key to keyserver
-  trust-keys (t) KEYID...               mark keyids as trusted
-  update-user-userids (u) USER UID...   add/update userids for a user
+  update-users (u) [USER]...            update users authorized_keys files
+  gen-key (g) [HOSTNAME]                generate gpg key for the server
+  show-fingerprint (f)                  show server's host key fingerprint
+  publish-key (p)                       publish server's host key to keyserver
+  trust-key (t) KEYID                   import and tsign a certification key
   help (h,?)                            this help
 
 EOF
 }
 
+su_monkeysphere_user() {
+    su --preserve-environment "$MONKEYSPHERE_USER" -- -c "$@"
+}
+
+# function to interact with the host gnupg keyring
+gpg_host() {
+    local returnCode
+
+    GNUPGHOME="$GNUPGHOME_HOST"
+    export GNUPGHOME
+
+    # NOTE: we supress this warning because we need the monkeysphere
+    # user to be able to read the host pubring.  we realize this might
+    # be problematic, but it's the simplest solution, without too much
+    # loss of security.
+    gpg --no-permission-warning "$@"
+    returnCode="$?"
+
+    # always reset the permissions on the host pubring so that the
+    # monkeysphere user can read the trust signatures
+    chgrp "$MONKEYSPHERE_USER" "${GNUPGHOME_HOST}/pubring.gpg"
+    chmod g+r "${GNUPGHOME_HOST}/pubring.gpg"
+    
+    return "$returnCode"
+}
+
+# function to interact with the authentication gnupg keyring
+gpg_authentication() {
+    GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
+    export GNUPGHOME
+
+    su_monkeysphere_user "gpg $@"
+}
+
+# update authorized_keys for users
+update_users() {
+    if [ "$1" ] ; then
+       # get users from command line
+       unames="$@"
+    else
+       # or just look at all users if none specified
+       unames=$(getent passwd | cut -d: -f1)
+    fi
+
+    # set mode
+    MODE="authorized_keys"
+
+    # set gnupg home
+    GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
+
+    # check to see if the gpg trust database has been initialized
+    if [ ! -s "${GNUPGHOME}/trustdb.gpg" ] ; then
+       failure "GNUPG trust database uninitialized.  Please see MONKEYSPHERE-SERVER(8)."
+    fi
+
+    # make sure the authorized_keys directory exists
+    mkdir -p "${VARLIB}/authorized_keys"
+
+    # loop over users
+    for uname in $unames ; do
+       # check all specified users exist
+       if ! getent passwd "$uname" >/dev/null ; then
+           error "----- unknown user '$uname' -----"
+           continue
+       fi
+
+       # set authorized_user_ids and raw authorized_keys variables,
+       # translating ssh-style path variables
+       authorizedUserIDs=$(translate_ssh_variables "$uname" "$AUTHORIZED_USER_IDS")
+       rawAuthorizedKeys=$(translate_ssh_variables "$uname" "$RAW_AUTHORIZED_KEYS")
+
+       # if neither is found, skip user
+       if [ ! -s "$authorizedUserIDs" ] ; then
+           if [ "$rawAuthorizedKeys" = '-' -o ! -s "$rawAuthorizedKeys" ] ; then
+               continue
+           fi
+       fi
+
+       log "----- user: $uname -----"
+
+        # make temporary directory
+        TMPDIR=$(mktemp -d)
+
+       # trap to delete temporary directory on exit
+       trap "rm -rf $TMPDIR" EXIT
+
+        # create temporary authorized_user_ids file
+        TMP_AUTHORIZED_USER_IDS="${TMPDIR}/authorized_user_ids"
+        touch "$TMP_AUTHORIZED_USER_IDS"
+
+        # create temporary authorized_keys file
+        AUTHORIZED_KEYS="${TMPDIR}/authorized_keys"
+        touch "$AUTHORIZED_KEYS"
+
+        # set restrictive permissions on the temporary files
+       # FIXME: is there a better way to do this?
+        chmod 0700 "$TMPDIR"
+        chmod 0600 "$AUTHORIZED_KEYS"
+        chmod 0600 "$TMP_AUTHORIZED_USER_IDS"
+        chown -R "$MONKEYSPHERE_USER" "$TMPDIR"
+
+       # if the authorized_user_ids file exists...
+       if [ -s "$authorizedUserIDs" ] ; then
+            # copy user authorized_user_ids file to temporary
+            # location
+           cat "$authorizedUserIDs" > "$TMP_AUTHORIZED_USER_IDS"
+
+           # export needed variables
+           export AUTHORIZED_KEYS
+           export TMP_AUTHORIZED_USER_IDS
+
+           # process authorized_user_ids file, as monkeysphere
+           # user
+           su_monkeysphere_user \
+               ". ${SHARE}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
+           ERR="$?"
+       fi
+
+       # add user-controlled authorized_keys file path if specified
+       if [ "$rawAuthorizedKeys" != '-' -a -s "$rawAuthorizedKeys" ] ; then
+           log -n "adding raw authorized_keys file... "
+           cat "$rawAuthorizedKeys" >> "$AUTHORIZED_KEYS"
+           loge "done."
+       fi
+
+       # openssh appears to check the contents of the
+        # authorized_keys file as the user in question, so the
+        # file must be readable by that user at least.
+       # FIXME: is there a better way to do this?
+       chown root "$AUTHORIZED_KEYS"
+       chgrp $(getent passwd "$uname" | cut -f4 -d:) "$AUTHORIZED_KEYS"
+       chmod g+r "$AUTHORIZED_KEYS"
+
+       # if the resulting authorized_keys file is not empty, move
+       # it into place
+       mv -f "$AUTHORIZED_KEYS" "${VARLIB}/authorized_keys/${uname}"
+
+       log "authorized_keys file updated."
+
+       # destroy temporary directory
+       rm -rf "$TMPDIR"
+    done
+}
+
 # generate server gpg key
 gen_key() {
+    local hostName
+    local userID
+    local keyParameters
+    local fingerprint
+
+    hostName=${1:-$(hostname --fqdn)}
+
+    SERVICE=${SERVICE:-"ssh"}
+    userID="${SERVICE}://${hostName}"
+
+    if gpg_host --list-key ="$userID" > /dev/null 2>&1 ; then
+       failure "Key for '$userID' already exists"
+    fi
+
     # set key defaults
     KEY_TYPE=${KEY_TYPE:-"RSA"}
     KEY_LENGTH=${KEY_LENGTH:-"2048"}
-    KEY_USAGE=${KEY_USAGE:-"encrypt,auth"}
-    SERVICE=${SERVICE:-"ssh"}
-    HOSTNAME_FQDN=${HOSTNAME_FQDN:-$(hostname -f)}
-
-    USERID=${USERID:-"$SERVICE"://"$HOSTNAME_FQDN"}
+    KEY_USAGE=${KEY_USAGE:-"auth"}
+    KEY_EXPIRE=${KEY_EXPIRE:-"0"}
+    cat <<EOF
+Please specify how long the key should be valid.
+         0 = key does not expire
+      <n>  = key expires in n days
+      <n>w = key expires in n weeks
+      <n>m = key expires in n months
+      <n>y = key expires in n years
+EOF
+    read -p "Key is valid for? ($KEY_EXPIRE) " KEY_EXPIRE; KEY_EXPIRE=${KEY_EXPIRE:-"0"}
 
     # set key parameters
     keyParameters=$(cat <<EOF
 Key-Type: $KEY_TYPE
 Key-Length: $KEY_LENGTH
 Key-Usage: $KEY_USAGE
-Name-Real: $USERID
+Name-Real: $userID
+Expire-Date: $KEY_EXPIRE
 EOF
 )
 
-    # add the revoker field if requested
+    # add the revoker field if specified
+    # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.  why?
+    # FIXME: why is this marked "sensitive"?  how will this signature ever
+    # be transmitted to the expected revoker?
     if [ "$REVOKER" ] ; then
        keyParameters="${keyParameters}"$(cat <<EOF
 
@@ -70,18 +244,14 @@ EOF
 )
     fi
 
-    echo "The following key parameters will be used:"
+    echo "The following key parameters will be used for the host private key:"
     echo "$keyParameters"
 
-    read -p "generate key? [Y|n]: " OK; OK=${OK:=Y}
+    read -p "Generate key? [Y|n]: " OK; OK=${OK:=Y}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
 
-    if gpg --list-key ="$USERID" > /dev/null 2>&1 ; then
-       failure "key for '$USERID' already exists"
-    fi
-
     # add commit command
     keyParameters="${keyParameters}"$(cat <<EOF
 
@@ -91,22 +261,100 @@ EOF
 )
 
     log "generating server key..."
-    echo "$keyParameters" | gpg --batch --gen-key
+    echo "$keyParameters" | gpg_host --batch --gen-key
+
+    # output the server fingerprint
+    fingerprint_server_key "=${userID}"
+
+    # find the key fingerprint of the server primary key
+    fingerprint=$(gpg_host --list-key --with-colons --with-fingerprint "=${userID}" | \
+       grep '^fpr:' | head -1 | cut -d: -f10)
+
+    # translate the private key to ssh format, and export to a file
+    # for sshs usage.
+    # NOTE: assumes that the primary key is the proper key to use
+    (umask 077 && \
+       gpg_host --export-secret-key "$fingerprint" | \
+       openpgp2ssh "$fingerprint" > "${VARLIB}/ssh_host_rsa_key")
+    log "Private SSH host key output to file: ${VARLIB}/ssh_host_rsa_key"
+}
+
+# gpg output key fingerprint
+fingerprint_server_key() {
+    gpg_host --fingerprint --list-secret-keys
 }
 
 # publish server key to keyserver
-publish_key() {
-    read -p "publish key to $KEYSERVER? [Y|n]: " OK; OK=${OK:=Y}
+publish_server_key() {
+    read -p "really publish key to $KEYSERVER? [y|N]: " OK; OK=${OK:=N}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
 
-    keyID=$(gpg --list-key --with-colons ="$USERID" 2> /dev/null | grep '^pub:' | cut -d: -f5)
-
+    # publish host key
+    # FIXME: need to figure out better way to identify host key
     # dummy command so as not to publish fakes keys during testing
     # eventually:
-    #gpg --send-keys --keyserver "$KEYSERVER" "$keyID"
-    echo "NOT PUBLISHED: gpg --send-keys --keyserver $KEYSERVER $keyID"
+    #gpg_authentication "--keyring $GNUPGHOME_HOST/pubring.gpg --keyserver $KEYSERVER --send-keys $(hostname -f)"
+    failure "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+}
+
+# retrieve key from web of trust, and set owner trust to "full"
+# if key is found.
+trust_key() {
+    local keyID
+    local trustLevel
+
+    keyID="$1"
+
+    # default values for trust depth and domain
+    DEPTH=${DEPTH:-1}
+    DOMAIN=${DOMAIN:-}
+
+    if [ -z "$keyID" ] ; then
+       failure "You must specify key to trust."
+    fi
+
+    export keyID
+
+    # export host ownertrust to authentication keyring
+    gpg_host --export-ownertrust | gpg_authentication "--import-ownertrust"
+
+    # get the key from the key server
+    gpg_authentication "--keyserver $KEYSERVER --recv-key $keyID"
+
+    # get the full fingerprint of a key ID
+    fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
+       grep '^fpr:' | grep "$keyID" | cut -d: -f10)
+
+    if [ -z "$fingerprint" ] ; then
+       failure "Could not find key '$keyID'."
+    fi
+
+    echo "key found:"
+    gpg_authentication "--fingerprint $fingerprint"
+
+    # export the key to the host keyring
+    gpg_authentication "--export $keyID" | gpg_host --import
+
+    # ltsign command
+    # NOTE: *all* user IDs will be ltsigned
+    ltsignCommand=$(cat <<EOF
+ltsign
+y
+2
+$DEPTH
+$DOMAIN
+y
+save
+EOF
+)
+
+    # ltsign the key
+    echo "$ltsignCommand" | gpg_host --quiet --command-fd 0 --edit-key "$fingerprint"
+
+    # update the trustdb for the authentication keyring
+    gpg_authentication "--check-trustdb"
 }
 
 ########################################################################
@@ -117,91 +365,52 @@ COMMAND="$1"
 [ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
 shift
 
-# set ms home directory
-MS_HOME=${MS_HOME:-"$ETC"}
-
 # load configuration file
-MS_CONF=${MS_CONF:-"$MS_HOME"/monkeysphere-server.conf}
+MS_CONF=${MS_CONF:-"${ETC}/monkeysphere-server.conf"}
 [ -e "$MS_CONF" ] && . "$MS_CONF"
 
 # set empty config variable with defaults
-GNUPGHOME=${GNUPGHOME:-"$MS_HOME"/gnupg}
-KEYSERVER=${KEYSERVER:-subkeys.pgp.net}
-REQUIRED_KEY_CAPABILITY=${REQUIRED_KEY_CAPABILITY:-"e a"}
-USER_CONTROLLED_AUTHORIZED_KEYS=${USER_CONTROLLED_AUTHORIZED_KEYS:-%h/.ssh/authorized_keys}
-
+MONKEYSPHERE_USER=${MONKEYSPHERE_USER:-"monkeysphere"}
+KEYSERVER=${KEYSERVER:-"subkeys.pgp.net"}
+CHECK_KEYSERVER=${CHECK_KEYSERVER:="true"}
+AUTHORIZED_USER_IDS=${AUTHORIZED_USER_IDS:-"%h/.config/monkeysphere/authorized_user_ids"}
+RAW_AUTHORIZED_KEYS=${RAW_AUTHORIZED_KEYS:-"%h/.ssh/authorized_keys"}
+
+# other variables
+REQUIRED_USER_KEY_CAPABILITY=${REQUIRED_USER_KEY_CAPABILITY:-"a"}
+GNUPGHOME_HOST=${GNUPGHOME_HOST:-"${VARLIB}/gnupg-host"}
+GNUPGHOME_AUTHENTICATION=${GNUPGHOME_AUTHENTICATION:-"${VARLIB}/gnupg-authentication"}
+
+# export variables
+export DATE
+export MODE
+export MONKEYSPHERE_USER
+export KEYSERVER
+export CHECK_KEYSERVER
+export REQUIRED_USER_KEY_CAPABILITY
+export GNUPGHOME_HOST
+export GNUPGHOME_AUTHENTICATION
 export GNUPGHOME
 
-# make sure gpg home exists with proper permissions
-mkdir -p -m 0700 "$GNUPGHOME"
-
 case $COMMAND in
-    'update-users'|'s')
-       if [ "$1" ] ; then
-           unames="$@"
-       else
-           unames=$(ls -1 "$MS_HOME"/authorized_user_ids)
-       fi
-
-       for uname in $unames ; do
-           MODE="authorized_keys"
-
-           log "----- user: $uname -----"
-
-           AUTHORIZED_USER_IDS="$MS_HOME"/authorized_user_ids/"$uname"
-           msAuthorizedKeys="$CACHE"/"$uname"/authorized_keys
-           cacheDir="$CACHE"/"$uname"/user_keys
-
-            # make sure authorized_user_ids file exists
-           if [ ! -s "$AUTHORIZED_USER_IDS" ] ; then
-               log "authorized_user_ids file for '$uname' is empty or does not exist."
-               continue
-           fi
-
-           # set user-controlled authorized_keys file path
-           if [ "$USER_CONTROLLED_AUTHORIZED_KEYS" ] ; then
-               userHome=$(getent passwd "$uname" | cut -d: -f6)
-               userAuthorizedKeys=${USER_CONTROLLED_AUTHORIZED_KEYS/\%h/"$userHome"}
-           fi
-
-           # update authorized_keys
-           update_authorized_keys "$msAuthorizedKeys" "$userAuthorizedKeys" "$cacheDir"
-       done
-
-       log "----- done. -----"
+    'update-users'|'update-user'|'u')
+       update_users "$@"
        ;;
 
     'gen-key'|'g')
-       gen_key
+       gen_key "$@"
        ;;
 
-    'publish-key'|'p')
-       publish_key
+    'show-fingerprint'|'f')
+       fingerprint_server_key
        ;;
 
-    'trust-keys'|'t')
-       if [ -z "$1" ] ; then
-           failure "you must specify at least one key to trust."
-       fi
-       for keyID ; do
-           trust_key "$keyID"
-       done
+    'publish-key'|'p')
+       publish_server_key
        ;;
 
-    'update-user-userids'|'u')
-       uname="$1"
-       shift
-       if [ -z "$uname" ] ; then
-           failure "you must specify user."
-       fi
-       if [ -z "$1" ] ; then
-           failure "you must specify at least one userid."
-       fi
-       AUTHORIZED_USER_IDS="$MS_HOME"/authorized_user_ids/"$uname"
-       cacheDir="$CACHE"/"$uname"/user_keys
-       for userID ; do
-           update_userid "$userID" "$cacheDir"
-       done
+    'trust-key'|'t')
+       trust_key "$@"
        ;;
 
     'help'|'h'|'?')
@@ -210,6 +419,8 @@ case $COMMAND in
 
     *)
         failure "Unknown command: '$COMMAND'
-Type 'cereal-admin help' for usage."
+Type '$PGRM help' for usage."
         ;;
 esac
+
+exit "$ERR"